## Containers

This repository contains various docker images that I found useful. These are
typically not very complex, usually not more than an alpine image with a few
packages installed.

Right now I'm using these primarily in my Woodpecker CI steps, but they are
regular docker images and can be used anywhere.

These containers are automatically updated every week, so they should stay fresh!

### rsync

[![Docker Pulls](https://img.shields.io/docker/pulls/seriousbug/rsync) ![Docker Image Size (tag)](https://img.shields.io/docker/image-size/seriousbug/rsync/latest)](https://hub.docker.com/r/seriousbug/rsync)

Gives you access to `rsync`, `ssh`, and `scp` commands.

### rust

[![Docker Pulls](https://img.shields.io/docker/pulls/seriousbug/rust) ![Docker Image Size (tag)](https://img.shields.io/docker/image-size/seriousbug/rust/latest)](https://hub.docker.com/r/seriousbug/rust)

Rust stable toolchain, with `rustup`, `binstall`, `fmt`, `clippy`, `llvm-cov`, `llvm-tools`, and `audit`.

This is a pretty heavy package as it contains a lot of libraries and other
things I found useful for my work.

---

## Adding a new container

1. Add a new folder, named after the container.
1. Create a Dockerfile inside of that folder, and fill out the dockerfile.
1. Go to Dockerhub, and create a repository for this new container.
1. Under `.woodpecker/`, copy an existing pipeline. Name the copy after the container.
1. Update the new pipeline:
   - Update the `repo: ...` to match the new repo you created
   - Point `dockerfile: ...` to the new dockerfile
   - Update `when: ...` condition so it's built when the correct folder is updated
